/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 *  $Id$
 *
 *
 *  $Log$
 *  Revision 1.2  2002/04/22 22:16:36  nat
 *  Noch ein bischen mehr code, genug fuer heute
 *
 *  Revision 1.1.1.1  2002/04/21 23:58:37  nat
 *  Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */
#ifndef MULLE_EO_INTERFACE_DEFINES_H__
#define MULLE_EO_INTERFACE_DEFINES_H__

#import <Foundation/Foundation.h>

#define STRICT_CHECKING          0      // for EOModeler and Debug = 0 otherwise 1
#define ENABLE_KEYPATHS          0

#define DEBUG_ASPECT_CONNECTOR  (defined( DEBUG) & 0)
#define DEBUG_ASPECT_CONNECTOR_VERBOSE  (DEBUG_ASPECT_CONNECTOR & 0)
#ifndef DEBUG_CODER
#define DEBUG_CODER             (defined( DEBUG) & 0)
#endif
#define DEBUG_SUBJECT_CHANGED   (defined( DEBUG) & 0)
#define DEBUG_FLUSH             (defined( DEBUG) & 0)
#define DEBUG_VERBOSE           (defined( DEBUG) & 0)
#define DEBUG_HARDCORE          (defined( DEBUG) & 0)   // aborts when peeved
#define DONT_CATCH_EXCEPTIONS   (defined( DEBUG) & 0)

#if DONT_CATCH_EXCEPTIONS
#undef NS_DURING
#undef NS_HANDLER
#undef NS_ENDHANDLER
#define localException  nil
#define NS_DURING       
#define NS_HANDLER      if( 0) {
#define NS_ENDHANDLER   }
#endif


static inline void   BAIL( Class aClass, SEL _cmd, BOOL classMethod)
{
   [NSException raise:NSGenericException
               format:@"%@ needs to implement %c%@",
NSStringFromClass( aClass), classMethod ? '+' : '-', NSStringFromSelector( _cmd)];
}


static inline void   FAIL( Class aClass, SEL _cmd, BOOL classMethod)
{
   NSLog( @"%@ needs to implement %c%@",
NSStringFromClass( aClass), classMethod ? '+' : '-', NSStringFromSelector( _cmd));
}

#define INSTANCE_FAIL()   FAIL( isa, _cmd, NO);
#define CLASS_FAIL()      FAIL( self, _cmd, YES);


static inline Class   _isa( NSObject *obj)
{
   return( ((struct { @defs( NSObject) } *) obj)->isa);
}

#endif
