/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "EOAssociation+RenderCellByAspect.h"

#import "NSCell+EOAssociationBoldAndItalic.h"


@implementation EOAssociation ( RenderCellByAspect)

- (void) _renderCell:(id) cell
       enabledAspect:(NSString *) enabledAspect
         colorAspect:(NSString *) colorAspect
          boldAspect:(NSString *) boldAspect
        italicAspect:(NSString *) italicAspect
              forRow:(int) row
{
   id        value;
   BOOL      isBold;
   BOOL      isItalic;
   NSColor   *color;
   
   if( enabledAspect)
   {
      value = [self valueForAspect:enabledAspect
                           atIndex:row];
      if( [value respondsToSelector:@selector( boolValue)])
         [cell setEnabled:[value boolValue]];
      else
         [cell setEnabled:value != nil];
   }
   
   if( colorAspect)
   {
      // not all cells do...
      if( [cell respondsToSelector:@selector( setTextColor:)])
      {
         color = [self valueForAspect:colorAspect
                              atIndex:row];
         NSParameterAssert( ! color || [color isKindOfClass:[NSColor class]]);
         if( ! color)
            color = [NSColor textColor];
         [cell setTextColor:color];
      }
   }
   
   if( ! boldAspect && ! italicAspect)
      return;
   
   isBold   = NO;
   isItalic = NO;
   if( boldAspect)
   {
      value  = [self valueForAspect:boldAspect
                            atIndex:row];
      isBold = [value boolValue];
   }
   
   if( italicAspect)
   {
      value    = [self valueForAspect:italicAspect
                              atIndex:row];
      isItalic = [value boolValue];
   }
   
   [cell _changeFontToBold:isBold
                    italic:isItalic];
}

@end
