/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 *
 */
#import <Foundation/Foundation.h>


typedef struct
{
   id             obj;
   unsigned int   tag;
} _EOInterfaceObjectWithTag;


@interface _EOInterfaceUniqueObjectsAndTags : NSObject
{
   unsigned int                count_;
   unsigned int                size_;
   _EOInterfaceObjectWithTag   *storage_;
   NSHashTable                 *objects_; // just used as dupe check
   NSHashTable                 *tags_;    // just used as dupe check
   BOOL                        haveZeroTag_;  // for tags_ hashTable
}

- initWithCapacity:(unsigned int) max;

// duplicate objects or tags won't be added and will return NO
- (BOOL) addObject:(id) obj
           withTag:(unsigned int) tag;

- (BOOL) insertObject:(id) obj
              withTag:(unsigned int) tag
              atIndex:(unsigned int) index;

- (unsigned int) count;
//- (id) objectAtIndex:(unsigned int) i
//      returningTagIn:(unsigned int) *tag;

- (void) sortUsingSelector:(SEL) sel;

- (NSArray *) allIndexes;
- (NSArray *) allObjects;

- (id) objectAtIndex:(unsigned int) i;
- (unsigned int) tagAtIndex:(unsigned int) i;
- (unsigned int) tagForObject:(id) object;

@end
