/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 * $Log$
 * Revision 1.1.1.1  2002/04/21 23:58:37  nat
 * Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */
#import "Defines.h"

#import "EOActionCellAssociation.h"

#import <AppKit/AppKit.h>
#import "EODisplayGroup.h"
#import "AspectsAndKeys.h"


//
// "refactor" this for a common class of cell and
// NSControl
//
@implementation EOActionCellAssociation


+ (BOOL) isUsableWithObject:(id) object
{
   return( [object isKindOfClass:[NSCell class]]);
}


- (NSControl *) control
{
#if DEBUG_VERBOSE
   NSLog( @"Control %@", [_object controlView]);
#endif
   return( (NSControl *) [_object controlView]);
}


#if DEBUG

- (void) establishConnection
{
   NSActionCell   *cell;
   BOOL           flag;
   
   [super establishConnection];

   cell = [self object];
   flag = ! [cell sendsActionOnEndEditing];
   if( flag)
      NSLog( @"*** %s <%@ %p> Warning: cell does not send ActionOnEndEditing. Edits may be therefore be lost", __PRETTY_FUNCTION__, [self class], self);
}


- (void) subjectChanged
{
   [super subjectChanged];
}


- (void) objectChanged
{
   [super objectChanged];
}


#endif

@end


