/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 *  $Id$
 *
 *  $Log$
 */
#import "Defines.h"

#import "EOColumnAssociation+OutlineView.h"

#import <AppKit/AppKit.h>
#import "AspectsAndKeys.h"


@implementation EOColumnAssociation ( OutlineView)

static inline id   emptyValueForCell( NSCell *cell)
{
   return( [cell isKindOfClass:[NSTextFieldCell class]] ? @"" : nil);
}


static inline id   emptyValueForTableColumn( NSTableColumn *column)
{
   return( emptyValueForCell( [column dataCell]));
}


- (id) 	       outlineView:(NSOutlineView *) view
 objectValueForTableColumn:(NSTableColumn *) column
                    byItem:(id) item
{
   id         value;
   NSString   *valueKey;
   
   valueKey = [self displayGroupKeyForAspect:MulleEOInterfaceValueAspect];
   value    = [item valueForKeyPath:valueKey];
   return( value ? value : emptyValueForTableColumn( column));
   
}


- (void) outlineView:(NSOutlineView *) outlineView
      setObjectValue:(id) value
      forTableColumn:(NSTableColumn *) tableColumn
              byItem:(id) item
{
#if DEBUG_VERBOSE
   NSLog( @"%@ %s %@ %@ %@ %@", self, __PRETTY_FUNCTION__, outlineView, value, tableColumn, item);
#endif
   //
   // don't use the EODisplayGroup, because
   // we may set values on objects, it doesn't
   // know about (deep in the tree)
   //
NS_DURING
   [item takeValue:value
        forKeyPath:[self displayGroupKeyForAspect:MulleEOInterfaceValueAspect]];
NS_HANDLER
   NSLog( @"%@: Setting of object value %@ for key %@ failed for EO %@ ",
             self, value, [self displayGroupKeyForAspect:MulleEOInterfaceValueAspect], item);
NS_ENDHANDLER
}


@end
