/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 * Revision 1.1.1.1  2002/04/21 23:58:37  nat
 * Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */

#ifndef _EOCOLUMNASSOCIATION_H
#define _EOCOLUMNASSOCIATION_H

#import "EOAssociation.h"
#import "EODisplayGroup.h"


@class NSControl;
@class NSTableColumn;
@class NSTableView;
@class NSText;


@interface EOColumnAssociation : EOAssociation
{
    unsigned   _didChange:1;
    unsigned   _alreadySetObject:1;
    unsigned   _enabledAspectBound:1;
    unsigned   _colorAspectBound:1;
    
    unsigned   _boldAspectBound:1;
    unsigned   _italicAspectBound:1;
    unsigned   _sortingEnabled:1;
    unsigned   _caseInsensitiveSorting:1;

    unsigned   _cycleWithNilSorting:1;
    unsigned   _showIndicatorImage:1;

    unsigned   _unused:22;

    SEL        _sortingSelector;
}

+ (NSArray *) columnAssociationsForTableView:(NSTableView *) tableView;
+ (EOColumnAssociation *) columnAssociationForTableColumn:(NSTableColumn *) column;

- (void) setSortingSelector:(SEL) selector;
- (SEL) sortingSelector;
- (void) tableColumnDealloced;
- (EOSortOrdering *) sortOrdering;

- (void) setSortingEnabled:(BOOL) flag;
- (BOOL) sortingEnabled;

- (id)            tableView:(NSTableView *) tableView
  objectValueForTableColumn:(NSTableColumn *) tableColumn
                        row:(int)row;

- (void)          tableView:(NSTableView *) tableView
             setObjectValue:(id)object
             forTableColumn:(NSTableColumn *) tableColumn
                        row:(int)row;

- (void)          tableView:(NSTableView *) tableView
            willDisplayCell:(id)cell
             forTableColumn:(NSTableColumn *) tableColumn
                        row:(int)row;

- (BOOL)          tableView:(NSTableView *) tableView
      shouldEditTableColumn:(NSTableColumn *) tableColumn
                        row:(int)row;

- (BOOL)            control:(NSControl *) control
              isValidObject:(id)obj;

- (BOOL)            control:(NSControl *) control
      didFailToFormatString:(NSString *) string
           errorDescription:(NSString *) errorDescription;

- (BOOL)            control:(NSControl *) control
     textShouldBeginEditing:(NSText *) fieldEditor;

@end

#endif
