/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 * Revision 1.1.1.1  2002/04/21 23:58:37  nat
 * Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */
#import "Defines.h"

#import "EOMasterPeerAssociation.h"

#import "AspectsAndKeys.h"
#import "EODisplayGroup.h"
#import "EODisplayGroup+Selection.h"
#import "EOAssociation+EODisplayGroupAssociation.h"
#import "EOInterfaceNotifications.h"


@implementation EOMasterPeerAssociation


+ (BOOL) isUsableWithObject:(id) object
{
   if( ! [object isKindOfClass:[EODisplayGroup class]])
      return( NO);
   return( ! [[object dataSource] isKindOfClass:[EODetailDataSource class]]);
}


#if DEBUG
- (void) establishConnection
{
   [super establishConnection];
   [self establishConnectionWithDisplayGroup];
#warning (nat) no idea yet, what to do here
}


- (void) breakConnection
{
   [self breakConnectionWithDisplayGroup];
   [super breakConnection];
}
#endif


- (void) subjectChanged
{
   EODisplayGroup   *peer;
   EODisplayGroup   *group;
   NSString         *key;
   NSArray          *array;
   
   peer  = [self displayGroupForAspect:MulleEOInterfaceParentAspect];
   key   = [self displayGroupKeyForAspect:MulleEOInterfaceParentAspect];
   //
   // selection kopieren
   // the following code works, because we select lazily in the EODisplayGroup
   // we allow the selectedObjects to contain objects that are not displayed
   // objects (on passing in) the user of EODisplayGroup will never notice that...
   //
   if( [peer selectionOrContentsChanged])
   {
      array = [peer selectedObjects];
      if( key)
          array = [array valueForKey:key];

      group = [self object];
      [group selectObjectsIdenticalTo:array];
   }
}


- (BOOL) shouldRetainObjectWhileBeingEstablished
{
   return( NO);
}


@end


