/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 *  $Id$
 *
 *
 *  $Log$
 *  Revision 1.1.1.1  2002/04/21 23:58:37  nat
 *  Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */
#ifndef _EOPOPUPASSOCIATION_H
#define _EOPOPUPASSOCIATION_H

#import "EOAssociation.h"


@interface EOPopUpAssociation : EOAssociation
{
   int           _tagValueForOther;

   unsigned      _addedTempItem:1;
   unsigned      _allowNullSelection:1;
   unsigned      _selectedObjectConnected:1;
   unsigned      _selectedTagConnected:1;
   
   unsigned      _selectedTitleConnected:1;
   unsigned      _complained:1;        // addition
   unsigned      _emptyTitles:1;       // addition
   unsigned      _forceValidValue:1;   // addition

   unsigned      _disableIfInvalid:1;  // addition
   unsigned      _disableSorting:1;    // addition later: user should specify sortSelector:
   unsigned      _unused:6;        

   NSString      *_tempTitle;
   unsigned int  _lastSelectedIndex;
   int           ignore_;
   
   NSMapTable    *titleIndexMapping_;   // can't use tag as subclasses use it
}

- (void) setTagValueForOther:(int) newValue;
- (int) tagValueForOther;

// added API
- (void) setAllowsNullSelection:(BOOL) flag;
- (BOOL) allowsNullSelection;
- (BOOL) _updateWithIndexOfSelectedItem:(int) index;

@end

#endif
