/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 *  $Id$
 *
 *
 *  $Log$
 *  Revision 1.1.1.1  2002/04/21 23:58:37  nat
 *  Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */
#ifndef _EOTABLEVIEWASSOCIATIONDRAGNDROP_H
#define _EOTABLEVIEWASSOCIATIONDRAGNDROP_H


#import <AppKit/AppKit.h>


typedef enum
{
   EODragNDropRegistration = 0,
   EODragNDropPreparation  = 1,
   EODragNDropOperation    = 2,
   EODragNDropValidation   = 3,
   EODragNDropAcceptance   = 4,
} EODragNDropStage;


@class EODisplayGroup;
@class NSPasteboard;


//
// this is an ephemeral object, that does not retain
// any of it's ivars
//
@interface EOTableViewAssociationDragNDropInfo : NSObject
{
@public
   id                    association_;
   EODisplayGroup        *displayGroup_;
   NSPasteboard          *pasteboard_;
   id <NSDraggingInfo>   draggingInfo_;
   NSArray               *types_;
   EODragNDropStage      stage_;
   unsigned int          dragOperation_;
}

- (id)                  association;
- (EODisplayGroup *)    displayGroup;
- (NSArray *)           types;
- (NSPasteboard *)      pasteboard;
- (EODragNDropStage)    stage;
- (id <NSDraggingInfo>) draggingInfo;
- (unsigned int)        dragOperation;

- (void) setTypes:(NSArray *) types;
- (void) setDragOperation:(unsigned int) operation;

@end


extern NSString   *EOTableViewAssociationDragNDrop;
extern NSString   *EODragNDropInfo;

#endif
