/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "EODisplayGroup+DragNDrop.h"


@implementation EODisplayGroup ( DragNDrop)

#if 0 // MIGHT BE USEFUL SOME OTHER TIME
- (NSData *) dragNDropDataForObjects:(NSArray *) objects
{
   NSArchiver      *archiver;
   int             address;
   int             index;
   unsigned int    i, n;
   
   archiver = [[[NSArchiver alloc] initForWritingWithMutableData:[NSMutableData data]] autorelease];
   address  = (int) &self;
   [archiver encodeValuesOfObjCTypes:"ii", &address, &_allObjectsChangeCount];
   
   //
   // encode relative to "allObjects, not to displayedObjects"
   // makes this a little more "persistent" and safer
   //
   n = [objects count];
   [archiver encodeValueOfObjCType:@encode( int)
                                at:&n];
   for( i = 0; i < n; i++)
   {
      index = [objects objectAtIndex:i];
      if( index == NSNotFound)
         [NSException raise:NSInternalInconsistencyException
                     format:@"Internal inconsistency in EODisplayGroup: %@", self];
      [archiver encodeValueOfObjCType:@encode( int)
                                   at:&index];
   }
   return( [archiver archiverData]);
}


- (unsigned int) objectsCountFromNDropData:(NSData *) data
{
   NSUnarchiver     *unarchiver;
   int              address;
   int              generation;
   unsigned int     n;
   
   NSParameterAssert( ! data || [data isKindOfClass:[NSData class]]);
   
   unarchiver = [[[NSUnarchiver alloc] initForReadingWithData:data] autorelease];
   [unarchiver decodeValuesOfObjCTypes:"ii", &address, &generation];
   if( (int) self != address || generation != _allObjectsChangeCount)
      return( nil);
   
   [unarchiver decodeValueOfObjCType:"%d"
                                  at:&n];
   return( n);
}


- (NSArray *) objectsFromDragNDropData:(NSData *) data
{
   NSUnarchiver     *unarchiver;
   int              address;
   int              generation;
   NSMutableArray   *array;
   unsigned int     i, n;
   unsigned int     index;
   
   NSParameterAssert( ! data || [data isKindOfClass:[NSData class]]);
   
   unarchiver = [[[NSUnarchiver alloc] initForReadingWithData:data] autorelease];
   [unarchiver decodeValuesOfObjCTypes:"ii", &address, &generation];
   if( (int) self != address || generation != _allObjectsChangeCount)
      return( nil);
   
   [unarchiver decodeValueOfObjCType:@encode( int)
                                  at:&n];
   array = [NSMutableArray arrayWithCapacity:n];
   for( i = 0; i < n; i++)
   {
      [unarchiver decodeValueOfObjCTypes:@encode( int)
                                      at:&index];
      [array addObject:[_allObjects objectAtIndex:index]];
   }
   return( array);
}
#endif


@end
