/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "EODisplayGroup+EOActions.h"

#import "EODisplayGroup+InsertUpdateDelete.h"
#import "EODisplayGroup+Selection.h"
#import "EODisplayGroup+Private.h"
#import <AppKit/AppKit.h>


@implementation EODisplayGroup ( EOActions)

- (IBAction) selectNext:(id) sender
{
   resetCallAndCheck( self);
   [self selectNext];
}


- (IBAction) selectPrevious:(id) sender
{
   resetCallAndCheck( self);
   [self selectPrevious];
}


- (IBAction) fetch:(id) sender
{
   resetCallAndCheck( self);
   [self fetch];
}


- (IBAction) insert:(id) sender
{
   unsigned int  index;
   
   resetCallAndCheck( self);
   index = 0; // _nDisplayedObjects;
   if( _nSelectedObjects)
      index = [[[self selectionIndexes] lastObject] unsignedIntValue] + 1;
   [self insertObjectAtIndex:index];
}


- (IBAction) delete:(id) sender
{
   resetCallAndCheck( self);
   [self deleteSelection];
}


- (IBAction) qualifyDataSource:(id) sender
{
   resetCallAndCheck( self);
   [self qualifyDataSource];
}


- (IBAction) qualifyDisplayGroup:(id) sender
{
   resetCallAndCheck( self);
   [self qualifyDisplayGroup];
}


- (IBAction) enterQueryMode:(id) sender
{
   resetCallAndCheck( self);
   [self setInQueryMode:YES];
}

@end
