/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "EODisplayGroup+MulleEOStructureDump.h"

#import "EODisplayGroup+Associations.h"


#define DUMP_ASSOCIATIONS_TOO   1


@implementation EODisplayGroup ( MulleEOStructureDump)

- (NSString *) _mulleEOStructureDumpString:(char *) prefix
                                       set:(NSMutableSet *) set
{
   NSMutableString   *buf;
   NSString          *s;
   char              *p2;
#if DUMP_ASSOCIATIONS_TOO   
   unsigned int      i, n;
   id                assoc;
   NSArray           *array;
#endif
   
   if( [set containsObject:self])
      return( [super _mulleEOStructureDumpReferenceString]);
   
   s   = [NSString stringWithFormat:@"  %s", prefix];
   p2  = (char *) [s cString];
   buf = [NSMutableString string];
   
   [buf appendFormat:[super _mulleEOStructureDumpString:prefix
                                                    set:set]];
   
   // sometimes useful, sometimes a pain
#if DUMP_ASSOCIATIONS_TOO   
   array = [self observingAssociations];
   n = [array count];
   for( i = 0; i < n; i++)
   {
      assoc = [array objectAtIndex:i];
      [buf appendFormat:@"\n%sassociation %u: %@", prefix, i, [assoc _mulleEOStructureDumpString:p2
                                                                                             set:set]];
   }
   if( n)
      [buf appendString:@"\n"];
#endif   
   return( buf);
}

@end
