/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "NSMutableArray+MulleFastRemove.h"
#import "NSArray+MulleFastRemove.h"


@implementation NSMutableArray ( MulleFastRemove)

- (void) mulleRemoveObjectsInArray:(NSArray *) array 
{ 
   NSArray         *copy; 
   unsigned int     m; 
   unsigned int     n; 
   
   n = [array count]; 
   m = [self count]; 
   
   /* -- if u like -- */
   if( n < 16 || m < 16 || n * m < 1024)  // guessed values where copying does not pay off 
   { 
      [self removeObjectsInArray:array]; 
      return; 
   } 
   
   copy = [self mulleArrayByRemovingObjectsInArray:array];
   [self setArray:copy]; 
} 

@end
