/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "NSString+MulleKeyPrettyPrint.h"


@implementation NSString ( MulleKeyPrettyPrint)

//
// Seperate ABadLookingGirl into A Bad Looking Girl
//
- (NSString *) mulleDecapslifiedString:(BOOL) initialCap
{
   NSRange          range;
   NSCharacterSet   *set;
   unsigned int     len;
   NSString         *s;
   NSString         *sub;
   NSMutableString  *result;

   result = [NSMutableString string];
   set = [NSCharacterSet uppercaseLetterCharacterSet];
   s   = self;
   len = [self length];
   while( len > 1)
   {
      range = [[s substringFromIndex:1] rangeOfCharacterFromSet:set];
      if( range.length == 0)
         break;
      sub = [s substringWithRange:NSMakeRange( 0, range.location + 1)];
      if( initialCap)
      {
         sub = [sub capitalizedString];
         initialCap = NO;
      }
      [result appendString:sub];
      if( ! (len -= range.location + 1))
         return( result);
      [result appendString:@" "];
      s = [s substringFromIndex:range.location + 1];
   }

   if( initialCap)
      return( [s capitalizedString]);

   [result appendString:s];
   return( result);
}



//
// Seperate ABad::lookingGirl: into A Bad Looking Girl
// Ironically this method is just here for completeness, orthogonality
// as it will be called in HdT only with zero parameter methods
// thereby reducing to decapslifiedString:
//
- (NSString *) mulleDecapslifiedMethodString:(BOOL) initialCap
{
   NSString          *s;
   NSArray           *array;
   NSMutableString   *result;
   unsigned int      i, n;

   result = [NSMutableString string];
   array  = [self componentsSeparatedByString:@":"];
   n      = [array count];

   for( i = 0; i < n; i++)
   {
      s = [[array objectAtIndex:i] mulleDecapslifiedString:initialCap];
      if( [s length])
      {
         if( [result length])
            [result appendString:@" "];
         [result appendString:s];
      }
   }
   return( result);
}

@end
