/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 *
 * $Log$
 * Revision 1.1.1.1  2002/04/21 23:58:37  nat
 * Mercyful Release - Diese Version kann noch gaaaaa nix
 *
 */
#import "Defines.h"

#import "EOAspectConnector.h"

#import <AppKit/AppKit.h>
#import "MulleEOInterfaceParentIncludes.h"
#import <InterfaceBuilder/InterfaceBuilder.h>
#import "EOAssociation.h"


@implementation EOAspectConnector 

- initWithAssociation:(EOAssociation *) assoc
           aspectName:(NSString *) name
{
   [super init];

   association = [assoc retain];
   aspectName  = [name copyWithZone:[self zone]];

   return( self);
}


- (void) dealloc
{
#if DEBUG_ASPECT_CONNECTOR
   NSLog( @"%s %@", __PRETTY_FUNCTION__, self);
#endif   
   [association release];
   [aspectName release];
   [super dealloc];
}


- (void) removed
{
#if DEBUG_ASPECT_CONNECTOR
   NSLog( @"%s %@", __PRETTY_FUNCTION__, self);
#endif   
   [association release];
   association = nil;
}


- (EOAssociation *) association
{
#if DEBUG_ASPECT_CONNECTOR
   NSLog( @"%s %@", __PRETTY_FUNCTION__, self);
#endif   
   return( association);
}


- (NSString *) aspectName
{
#if DEBUG_ASPECT_CONNECTOR
   NSLog( @"%s %@", __PRETTY_FUNCTION__, self);
#endif   
   return( aspectName);
}


- (id) initWithCoder:(NSCoder *) decoder
{
   [super init];

//   [decoder decodeValuesOfObjCTypes:"@", &association];
//   [decoder decodeValuesOfObjCTypes:"@", &aspectName];

   [decoder decodeValuesOfObjCTypes:"@@", &association, &aspectName];
#if DEBUG_CODER
   NSLog( @"%s %@ (version:%d) aspect: \"%@\" for association %@", __PRETTY_FUNCTION__, self, [decoder versionForClassName:@"EOAspectConnector"], aspectName, association);
#endif   
   /*
   association = [[decoder decodeObject] retain];
   aspectName  = [[decoder decodeObject] retain];
*/   
   return( self);
}


- (void) encodeWithCoder:(NSCoder *) encoder
{
#if DEBUG_CODER
   NSLog( @"%s %@", __PRETTY_FUNCTION__, self);
#endif   
   [encoder encodeValuesOfObjCTypes:"@@", &association, &aspectName];
}


- (NSString *) destinationKey
{
   NSString  *s;
   
#if DEBUG_ASPECT_CONNECTOR
   NSLog( @"%s %@", __PRETTY_FUNCTION__, self);
#endif
   s = [association displayGroupKeyForAspect:aspectName];
   if( ! [s length])
   {
      s = @"???";
      if( [association displayGroupForAspect:aspectName])
         s = @"EODisplayGroup";
   }
   return( s);  // oder ??
}


@end

