/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2006 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "Defines.h"

#import "EOEditingContext+EOTaggedTargetAction.h"
#import <AppKit/AppKit.h>


@implementation EOEditingContext ( EOTaggedTargetAction)

/*
 - (void) saveChanges:(id) sender;
 - (void) refault:(id) sender;
 - (void) revert:(id) sender;
 - (void) refetch:(id) sender;
 
 - (void) undo:(id) sender;
 - (void) redo:(id) sender;
 */
- (void) performTargetActionUsingTagOfSender:(id) sender
{
   switch( [sender tag])
   {
   case EOEditingContextSaveChangesTag :
      [self saveChanges:sender];
      break;
      
   case EOEditingContextRefaultTag     :
      [self refault:sender];
      break;
      
   case EOEditingContextRevertTag      :
      [self revert:sender];
      break;
      
   case EOEditingContextRefetchTag     :
      [self refetch:sender];
      break;
      
   case EOEditingContextUndoTag        :
      [self undo:sender];
      break;
      
   case EOEditingContextRedoTag        :
      [self redo:sender];
      break;
      
   default :
      NSLog( @"***warning: tag %u is an unknown action for %@ %s", [sender tag], self, __PRETTY_FUNCTION__);
#if DEBUG
      abort();
#endif      
   }
}

@end
