/*
 *  MulleEOInterface - Replacement EOInterface Framework for EOF 
 *  Copyright (C) 2002 Mulle kybernetiK. All rights reserved.
 *
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; specifically
 *  version 2.1 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF
 *  WHICH MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE
 *  USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER
 *  DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 *  RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF
 *  ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 *  $Id$
 *
 *
 *  $Log$
 *
 */
#ifndef _MULLEEOINTERFACE_H
#define _MULLEEOINTERFACE_H

#define MULLE_EO_INTERFACE_VERSION_MAJOR     1
#define MULLE_EO_INTERFACE_VERSION_MINOR     3
#define MULLE_EO_INTERFACE_VERSION           ((MULLE_EO_INTERFACE_VERSION_MAJOR << 16) | MULLE_EO_INTERFACE_VERSION_MINOR)

#define MULLE_EO_INTERFACE                   0x0001  // just YES, not 1.0

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "MulleEOInterfaceParentIncludes.h"

#import "AspectsAndKeys.h"

#import	"EOAspectConnector.h"
#import	"EOAssociation.h"
#import	"EODisplayGroup.h"
#import	"EODisplayGroup+EOActions.h"
#import	"EODisplayGroup+Associations.h"
#import	"EODisplayGroup+InsertUpdateDelete.h"
#import	"EODisplayGroup+Objects.h"
#import	"EODisplayGroup+Selection.h"
#import	"EOEditingContext+EOTaggedTargetAction.h"

#import	"EOActionAssociation.h"
#import	"EOActionCellAssociation.h"
#import	"EOActionInsertionAssociation.h"
#import	"EOColumnAssociation.h"
#import	"EOComboBoxAssociation.h"
#import	"EOControlAssociation.h"
#import	"EODetailSelectionAssociation.h"
#import	"EOGenericControlAssociation.h"
#import	"EOMasterCopyAssociation.h"
#import	"EOMasterDetailAssociation.h"
#import	"EOMasterPeerAssociation.h"
#import	"EOMatrixAssociation.h"
#import	"EOOutlineViewAssociation.h"
#import	"EOOutlineViewAssociation+DragNDrop.h"
#import	"EOPickTextAssociation.h"
#import	"EOPopUpAssociation.h"
#import	"EORadioMatrixAssociation.h"
#import	"EORecursiveBrowserAssociation.h"
#import	"EOTableViewAssociation.h"
#import	"EOTableViewAssociation+DragNDrop.h"
#import	"EOTextAssociation.h"

#import "EOWindowStateReflector.h"
//
//
//
#import	"NSOutlineView+EODragNDrop.h"

//
// probably will never be supported, will they ?
//
#import	"EODictionaryDataSource.h"
#import	"EOQuickTimeView.h"
#import	"EOQuickTimeAssociation.h"

#endif
