//
//  NSObject+EOInterfaceKVCAdditions.m
//  MulleEOInterface
//
//  Created by Nat! on 14.02.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//
#import "Defines.h"

#import "NSObject+EOInterfaceKVCAdditions.h"
#import <EOControl/EOControl.h>


#if DEBUG  // coz the stupid debugger trips up on alloca stack frames
#define mulle_safe_alloca( size)  ((void *) [[NSMutableData dataWithLength:size] bytes])
#else
#define mulle_safe_alloca( size)  \
(alloca( size) ? : (void *) [[NSMutableData dataWithLength:size] bytes])
#endif


@implementation NSObject ( EOInterfaceKVCAdditions)

- (void) eoTakeValue:(id) value
          forKeyPath:(NSString *) path
{
   NSArray        *components;
   unsigned int   i, n;
   id             *buf;
   id             obj;
   NSString       *key;
   id             old;
   
   components = [path componentsSeparatedByString:@"."];
   
   obj = self;
   n   = [components count];
   buf = (id *) mulle_safe_alloca( sizeof( id) * n);
   [components getObjects:buf];
   
   if( --n)
      for( i = 0; i < n; i++)
         obj = [obj valueForKey:buf[ i]];
   
   key = buf[ n];
   
   //
   //  to One relationships
   //
   if( [[obj toOneRelationshipKeys] containsObject:key])
   {
      old = [self valueForKey:key];
      if( ! value)
      {
         if( ! old)
            return;
         [obj removeObject:old fromBothSidesOfRelationshipWithKey:key];
         return;
      }
      
      if( old == value)  
         return;
      [obj addObject:value toBothSidesOfRelationshipWithKey:key];
      return;
   }

   //
   // if it's a to many, then value is an array(!), they should not 
   // be handled with takeValue:forKeyPath: but we just pass it on
   //
   [self takeValue:value
            forKey:key];
}


@end
